<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: index.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: index.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ONLY FOR DOCUMENTATION ! - DEFINE ALL GLOBAL TYPES AND VARIABLES NEEDED FOR JSDOC DOCUMENTATION
// Start of declaration block
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

/**
  * Selection of used properties of a HTML node
  * @typedef {object} nodetype
  * @property {string} innerHTML inner/child HTML structure inside a HTML node
  * 
  */ 

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name d3
 * @class
 */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name d3#select
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */
  
/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name d3#selectAll
  * @param {nodetype} nodes - An integer.     
  * @param {string} nodes - A callback to run whose signature is (sum), where
  * @param {string} table - A callback to run whose signature is (sum), where
  *  sum is an integer.
  */

/**
 * @classdesc Class representing a socket connection.
 * @name selection
 * @class
 * @augments d3
 */

  /**  
  * Removes the current selection object from the HTML DOM
  * @method 
  * @name selection#remove
  * @param {object} this - uses the current selection object.     
  *  sum is an integer.
  */

/**  
  * Removes the current selection object from the HTML DOM
  * @method 
  * @name selection#node
  * @param {object} this - uses the current selection object.     
  *  sum is an integer.
  */

/**  
  * Removes the current selection object from the HTML DOM
  * @method 
  * @name selection#nodes
  * @param {object} this - uses the current selection object.     
  *  sum is an integer.
  */

/**
 * @classdesc Socket.io class
 * @name socket
 * @class
 */

/**  
  * Fires a callback on incoming message
  * @method 
  * @name socket#on
  * @param {string} messageID - string identifier input signal.     
  *  
  */

/**  
  * Fires a callback on incoming message
  * @method 
  * @name socket#emit
  * @param {string} messageID - string identifier out signal.     
  *  
  */

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name express
 * @class
 */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name express#use
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name express#set
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name express#static
  * @param {string} path - path.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name express#router
  * @description constructor of a router object
  */

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name router
 * @class
 * @augments express
 */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name router#get
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name router#post
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name response
 * @class
 */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name response#redirect
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name response#sendFile
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name server
 * @class
 */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name server#listen
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/** 
 * @classdesc Not a real class but an interface. Etc...
 * @name pool
 * @class
 */

 
/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#user
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */


/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#host
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#database
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#password
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#port
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */

/**  
  * Add two numbers together, then pass the results to a callback function.  
  * @method 
  * @name pool#connect
  * @param {nodetype} node - An integer.    
  *  sum is an integer.
  */
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// End of declaration block
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

/**
 * &lt;h2>Main module&lt;/h2>
 * &lt;p> This is the module description of the index.js main module in node.js. The project goal is to provide models, simulations
 * and controls methods for vehicle fleets. It starts out with a simulation environment of a static engine model. To understand the
 * details about the static engine model see {@tutorial staticEngineModel}&lt;/p>
 * &lt;h3>Webservers and clients of this application&lt;/h3>
 * &lt;table>
     * &lt;thead>&lt;tr>&lt;th>Servers&lt;/th>&lt;th>Clients&lt;/th>&lt;/tr>&lt;/thead>
     * &lt;tr>&lt;td>Postgres&lt;/td> &lt;td>node.js, jupyter&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>Node.js&lt;/td> &lt;td>Web Browser : calibration views + stimulation &amp; simulation view + static code view&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>Jupyter&lt;/td> &lt;td>Jupyter Notebooks&lt;/td>&lt;/tr>     
 * &lt;/table>
 * &lt;p> The project currently uses 3 docker containers: &lt;/p>
 * &lt;li>node.js container : calibration data and simulation control interface&lt;/li>
 * &lt;li>jupyter server and jupyter notebook container : static and dynamic engine models&lt;/li>
 * &lt;li>postgres container : database server for all needed by node and jupyter&lt;/li>
 * &lt;p>Continue reading this page to understand the details of the node.js container&lt;/p>
 * &lt;h3>Web Clients&lt;/h3>
 * &lt;p>To understand the concept of this main server module it is necessary to understand the web clients.
 * Find the overview in the web clients tutorial.{@tutorial webclients}&lt;/p>
 * &lt;h3>Parent module&lt;/h3>
 * &lt;p> This is the top level module. There is no parent module.&lt;/p>
 * &lt;h3>Child modules&lt;/h3>
 * &lt;p>A socketIO module is attached to the http server. Follow the attached link to find the details for the socket module : &lt;/p>
 * &lt;p>See {@link module:c_socketCom_server}&lt;/p>
 * &lt;h3>Clients and servers of this module&lt;/h3>
  * &lt;table>
     * &lt;thead>&lt;tr>&lt;th>Client&lt;/th>&lt;th>Table in Postgres Server&lt;/th>&lt;th>Description&lt;/th>&lt;/tr>&lt;/thead>
     * &lt;tr>&lt;td>/&lt;/td> &lt;td>ThermoBaseDataStationary&lt;/td>&lt;td>All engine parameters are described by JSONB information in table columns&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/&lt;/td> &lt;td>ThermoCalDataCurves&lt;/td>&lt;td>Data table for constants : Editors for constants are opened up in main view once a constant is selected&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/signals&lt;/td> &lt;td>not yet defined&lt;/td>&lt;td>simulation view is currently under development&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/Tree&lt;/td> &lt;td>not yet defined&lt;/td>&lt;td>static code analysis is under development&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/editsurface&lt;/td> &lt;td>ThermoCalDataMaps&lt;/td>&lt;td>data table for 3d edtor&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/editcurve&lt;/td> &lt;td>ThermoCalDataCurves&lt;/td>&lt;td>load 2d graphical curve editor&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/docs&lt;/td> &lt;td>no data tables used&lt;/td>&lt;td>currently no documentation data is stored in postgres&lt;/td>&lt;/tr>     
     * &lt;/table>   
 * &lt;p>The table shows the postgres data which is read and changed by the client calls according to the path shown in the first column&lt;/p>
 * &lt;p>Index.js is the main node.js module. It controls the following views : 
 * &lt;li>select and activate the below views (exception : editing calibration constants happens in the same view)&lt;/li>
 * &lt;li>3d map editor&lt;/li>
 * &lt;li>2d curve editors specialized in engine characteristics&lt;/li>
 * &lt;li>simulation&lt;/li>
 * &lt;li>static code analysis + placement of bypass and measurement hooks&lt;/li>
 * &lt;br>
 * "npm run start" activates the module.
 * It starts an http server on the given host at port 3000 or a port which is defined by 
 * the environment variable PORT.env. A socket connection is attached to the http server.
 * Major goal of the socket is the communication from an to a postgres database 
 * which stores all project related data. &lt;/p>
 * &lt;p> The router of a node express application is coordinating requests received from the 
 *  client &lt;/p>
 * 
 * 
 * &lt;p>The index.js main module provides the following services : &lt;/p> 
 * &lt;li>provide a set of public folders which may be accessed by client http requests&lt;/li>
 * &lt;li>routing for http get and post requests&lt;/li>
 * &lt;li>continuous client/server communication via socket.IO&lt;/li>
 * &lt;p> Members :  &lt;/p>
 * &lt;li> app_use : defines the public folders,the view engine, the router path &lt;/li>
 * &lt;li> socketCom : controls the socketIO communication between client and server &lt;/li>
 * &lt;li> path : controls the socketIO communication between client and server &lt;/li>
 * &lt;li> server : controls the socketIO communication between client and server &lt;/li>
 * &lt;li> router : controls the socketIO communication between client and server &lt;/li>
 * &lt;li> express : controls the socketIO communication between client and server &lt;/li>
 * 
 * &lt;p> Methods :  &lt;/p>
 * &lt;li> app_set() : defines pug as the view engine and the views folder as the location of views &lt;/li>
 * &lt;li> app_use() : defines the public folders and their path names &lt;/li>
 * &lt;li> bodyParser() : parses the http request bodies &lt;/li>
 * &lt;li> router_get() : http get service function &lt;/li>
 * &lt;li> router_post() : http post service function &lt;/li>
 * &lt;li> socket_com() : http post service function &lt;/li>
 * &lt;li> server_listen() : activates the listener of the server&lt;/li>
 * 
 * The main module creates and activates the http server. It coordinates the http get and post 
 * routes. 
 * 
 * @module a_index_server
 */

/**
 * @type {class} 
 * @description Load framework class
 */
const express = require('express');
/**
 * @type {express} 
 * @description Create the application object
 */
const app = express();
/**
 * @type {httpserver}
 * @description create http server object out of the application object
 */
const server = require('http').createServer(app);
/**
 * @type {object} 
 * @description get path object from path module
 */
const path = require('path');
/**
 * @type {object} 
 * @description get socket object with socket communication method from socketCom module
 */
const socketCom = require("./nodeScripts/socketCom.js");
/**
 * @type {router} 
 * @description get router module
 */
const router = express.Router();
/**
     * Define public folder and route names : 
     * &lt;table>
     * &lt;thead>&lt;tr>&lt;th>access from client&lt;/th>&lt;th>path on host&lt;/th>&lt;th>description&lt;/th>&lt;/tr>&lt;/thead>
     * &lt;tr>&lt;td>/HTML&lt;/td> &lt;td>__dirname + /HTML&lt;/td>&lt;td>contains all HTML client pages&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/View&lt;/td> &lt;td>__dirname + /View&lt;/td>&lt;td>contains the pug view engine source code&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/Script&lt;/td> &lt;td>__dirname + /Script&lt;/td>&lt;td>contains all javascript sources for the HTML pages&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/testdata&lt;/td> &lt;td>__dirname + /testdata&lt;/td>&lt;td>contains the model stimulation data&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/images&lt;/td> &lt;td>__dirname + /images&lt;/td>&lt;td>contains pictures in png format&lt;/td>&lt;/tr>
     * &lt;tr>&lt;td>/docs&lt;/td> &lt;td>__dirname + /docs&lt;/td>&lt;td>contains the documentation pages in HTML&lt;/td>&lt;/tr>     
     * &lt;/table>
     * @function app_use
     * 
     */
app.use('/node_modules',express.static(__dirname + '/node_modules'));

app.use('/HTML',express.static(__dirname + '/HTML'));

//Store all view engine files in view folder.
app.use('/View',express.static(__dirname + '/View'));

//Store all JS and CSS in Scripts folder.
app.use('/Script',express.static(__dirname + '/Script'));

app.use('/testdata',express.static(__dirname + '/testdata'));

app.use('/images',express.static(__dirname + '/images'));

app.use('/docs',express.static(__dirname + '/docs'));

/**
     * Set folder any type of view engine : 
     * &lt;p> folder : ./views
     * &lt;p> view engine : pug     
     * @function app_set
     * 
     */
app.set('views',path.join(__dirname+'/View'));
app.set('view engine','pug');

//add the router
app.use('/', router);

var table_data=[],curve_data=[];
/**
  * Launch socket communication 
  * @function socketCom
  * @description see {@link module:c_socketCom_server}
  */
socketCom(server,table_data,curve_data);


/**
  * Parses HTML structure sent by a http post request     
  * @function bodyParser
  */
const bodyParser = require('body-parser');

var urlencodedParser = bodyParser.urlencoded({ extended: true });
app.use(express.urlencoded({ extended: true }));
app.use(bodyParser.json());

/**
  * HTTP get service root
   * @function router_get_d
   * @param {string} / root path
   * @description By inserting the url path of this server together with the root path ("/") into the browser
   * address bar and pressing return, the browser sends a get request for the path "/" to the server. The server
   * replies by loading the '/HTML/dispatcher.html' file into the web client. On the reply the browser starts
   * to render the html file and executes the included javascript. Find more details about the client by following
   * the link. &lt;br>&lt;br>
   * [client : load and start function selection view]{@link b_create_caldata_buttons_client.b_1_dataviz}
  */

router.get('/',function(req,res){
    console.log('Select a function')  
    res.sendFile(path.join(__dirname + '/HTML/dispatcher.html'))
      //__dirname : It will resolve to your project folder.
    });

/**
  * HTTP get service signals
  * @function router_get_s
  * @param {string} /signals signals
  */
  router.get('/signals',function(req,res){
    console.log('Stimulation')  
    res.sendFile(path.join(__dirname + '/HTML/signalsNOsci.html'))
      //__dirname : It will resolve to your project folder.
    });

  /**
  * HTTP get service tree
  * @function router_get_t
  * @param {string} /tree d3treeAnimated.html does not use any
  * external javascript codes yet. This view uses json documents
  * and javascript code which is directly embedded into the html
  * for demonstration purposes. 
  * @description get request service on url path /tree. Replies by 
  * sending d3treeAnimated.html, which creates the static 
  * is sent to 
  */
  router.get('/Tree',function(req,res){
      console.log('Next step : loading HTML')
      res.sendFile(path.join(__dirname + '/HTML/d3treeAnimated.html'))
      //__dirname : It will resolve to your project folder.
    });
  
  /**
  * HTTP get service editsurface
  * @function router_get_es
  * @param {string} /editsurface url path
  * @description replies on the get request by sending /HTML/editableSurface.html
  * to the client. The html creates the 3d map visualization. 
  * &lt;br>[3d visualization]{@link module:l_3d_map_visualization_client}
  */    
  router.get('/editsurface',function(req,res){    
      res.sendFile(path.join(__dirname + '/HTML/editableSurface.html'))
      //__dirname : It will resolve to your project folder.
    });
  
  /**
  * HTTP get service editcurve
  * @function router_get_ec
  * @param {string} /editcurve url path
  * @description replies on the get request by sending /HTML/editableSurface.html
  * to the client. The html creates the 3d map visualization. 
  * &lt;br>[2d visualization]{@link module:m_curveGraphGenerator_client}
  */    
  router.get('/editcurve',function(req,res){    
      res.sendFile(path.join(__dirname + '/HTML/editableCurve.html'))
      //__dirname : It will resolve to your project folder.
    });
  
  /**
  * HTTP get service docs
  * @function router_get_dc
  * @param {string} /docs url path
  * @description load /docs/index.html which creates the
  * documentation view 
  */            
    router.get('/docs',function(req,res){    
      res.sendFile(path.join(__dirname + '/docs/index.html'))
      //__dirname : It will resolve to your project folder.
    });
  
/**
  * HTTP post service
  * &lt;p> - client HTML information sent by the post request is parsed
  * and the HTML page is redirected to a destination route according
  * to a request information which is contained in the HTML 
  * The post requests of this application are sent by submit buttons 
  * in client HTML forms&lt;/p>
  * 
  * Routes : 
  * &lt;table>
  *   &lt;tr>&lt;th>path req. client&lt;/th>&lt;th>ActiveView == 'map'&lt;/th>&lt;th>ActiveView == 'curve'&lt;/th>&lt;th>Description&lt;/th>&lt;/tr>
  *   &lt;tr>&lt;td>/submit&lt;/td> &lt;td>/editsurface&lt;/td>&lt;td>/editcurve&lt;/td>&lt;td>Redirect request to corresponding graphical editor&lt;/td>&lt;/tr>
  *   &lt;tr>&lt;td>/signals&lt;/td> &lt;td>/signals&lt;/td>&lt;td>/signals&lt;/td>&lt;td>Redirect to stimulation view&lt;/td>&lt;/tr>
  *   &lt;tr>&lt;td>/staticcode&lt;/td> &lt;td>/tree&lt;/td>&lt;td>/tree&lt;/td>&lt;td>Redirect tree view for static code analysis&lt;/td>&lt;/tr>
  * &lt;/table>
  * 
  * @function router_post
  */

 /**
  * HTTP post on path 'submit' is triggered by pressing the submit button in an input form of
  * the function selection view. The http post service is checking the status of an active 
  * view flag before it activates either a 3d map editor or a 2d map editor. &lt;br>&lt;br>
  * Find details about the decision logic in &lt;br> [get active view from postgres]{@link module:a_index_server~pgGetFnc}
  * @function router_post_sbm
  * @param {string} /submit
  * @param {object} urlencodedParser
  * @param {function} function() [get active view from postgres]{@link module:a_index_server~pgGetFnc}
  */            
  router.post('/submit',urlencodedParser,function(req,res){
    
    /**
      * HTTP get service docs
      * @function pgGetFnc
      * @param {string} 'ActiveView' 'constant','map','curve'
      * @description The active view postgres interface is used by the 'submit' post request. 
      * Depending on the status of the 'ActiveView' information in postgres the post request
      * is redirected in the following way : &lt;br>
      * &lt;li>'ActiveView' equals 'map' : &amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;[redirect 3d map editor]{@link module:a_index_server~response_redirect_m}&lt;/li>
      * &lt;li>ActiveView' equals 'curve' :&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;[redirect 2d curve editor]{@link module:a_index_server~response_redirect_c}&lt;/li>
      */            
      var pgGetFnc =require("./nodeScripts/getPostgresWOsocket.js")
      pgGetFnc('ActiveView').then(
        function(data)
        {
          console.log(data);
          if(data.rows[0].View.view == 'map')
          {
                /**
                  * HTTP get service docs
                  * @function response_redirect_m
                  * @param {string} '/editsurface' redirects node express router to the
                  * /editsurfe url path. 
                  * @description 'ActiveView' status is equal to 'map'
                  * the 3d editing view is activated by redirecting the post
                  * request. 
                  * &lt;br>&lt;br>[see get request for edit surface]{@link module:a_index_server~router_get_es}
                  */
            res.redirect('/editsurface');
          }
          if(data.rows[0].View.view == 'curve')
          {
                /**
                  * HTTP get service docs
                  * @function response_redirect_c
                  * @param {string} '/editcurve' redirects node express router to the
                  * /editsurfe url path. 
                  * @description 'ActiveView' status is equal to 'curve'
                  * the 2d editing view is activated by redirecting the post
                  * request. 
                  * &lt;br>&lt;br>[see get request for edit curve]{@link module:a_index_server~router_get_ec}
                  */
            res.redirect('/editcurve');
          }
        }); 
  });

  /**
  * HTTP get service signals
  * @function router_post_sig
  * @param {string} /signals
  * @param {object} urlencodedParser
  * @param {function} redirect_s Redirects the 'signals' post request to the 'signals'
  * get request.
  * &lt;br>[see get request for signals]{@link module:a_index_server~router_get_s}
  */   
  router.post('/signals',urlencodedParser,function(req,res){
   
      console.log(req);
      res.redirect('/signals');    
      
  });
  
  /**
  * HTTP get service static code
  * @function router_post_stc
  * @param {string} /staticcode
  * @param {object} urlencodedParser
  * @param {function} function()
  */   
  router.post('/staticcode',urlencodedParser,function(req,res){
    
    console.log(req);
    res.redirect('/Tree');
    
  });

let port = process.env.PORT || 3000

/**
  * The server starts listening to a defined port and host 
  * @function server_listen
  */

server.listen(port,'0.0.0.0');

console.log('Running at Port',port);

module.exports = app;

</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
